Crypto++ 8.2 Free C++ class library of cryptographic schemes

Classes | Public Member Functions | List of all members
MeterFilter Class Reference

Measure how many bytes and messages pass through the filter. More...

Inheritance diagram for MeterFilter:

## Public Member Functions
| MeterFilter (BufferedTransformation *attachment=NULL, bool transparent=true)
| Construct a MeterFilter. More...
void | SetTransparent (bool transparent)
| Set or change the transparent mode of this object. More...
void | AddRangeToSkip (unsigned int message, lword position, lword size, bool sortNow=true)
| Adds a range to skip during processing. More...
void | ResetMeter ()
| Resets the meter. More...
void | IsolatedInitialize (const NameValuePairs &parameters)
| Initialize or reinitialize this object, without signal propagation. More...
lword | GetCurrentMessageBytes () const
| Number of bytes in the current message. More...
lword | GetTotalBytes () const
| Number of bytes processed by the filter. More...
unsigned int | GetCurrentSeriesMessages () const
| Message number in the series. More...
unsigned int | GetTotalMessages () const
| Number of messages in the message series. More...
unsigned int | GetTotalMessageSeries () const
| Number of messages processed by the filter. More...
byte * | CreatePutSpace (size_t &size)
| Request space which can be written into by the caller. More...
size_t | Put2 (const byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes for processing. More...
size_t | PutModifiable2 (byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee. More...
bool | IsolatedMessageSeriesEnd (bool blocking)
| Marks the end of a series of messages, without signal propagation. More...
Public Member Functions inherited from Bufferless< Filter >
bool | IsolatedFlush (bool hardFlush, bool blocking)
| Flushes data buffered by this object, without signal propagation. More...
Public Member Functions inherited from Filter
| Filter (BufferedTransformation *attachment=NULL)
| Construct a Filter. More...
bool | Attachable ()
| Determine if attachable. More...
BufferedTransformation * | AttachedTransformation ()
| Retrieve attached transformation. More...
const BufferedTransformation * | AttachedTransformation () const
| Retrieve attached transformation. More...
void | Detach (BufferedTransformation *newAttachment=NULL)
| Replace an attached transformation. More...
size_t | TransferTo2 (BufferedTransformation &target, lword &transferBytes, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer bytes from this object to another BufferedTransformation. More...
size_t | CopyRangeTo2 (BufferedTransformation &target, lword &begin, lword end=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true) const
| Copy bytes from this object to another BufferedTransformation. More...
void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| Initialize or reinitialize this object, with signal propagation. More...
bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output, with signal propagation. More...
bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| Marks the end of a series of messages, with signal propagation. More...
Public Member Functions inherited from BufferedTransformation
| BufferedTransformation ()
| Construct a BufferedTransformation.
BufferedTransformation & | Ref ()
| Provides a reference to this object. More...
size_t | Put (byte inByte, bool blocking=true)
| Input a byte for processing. More...
size_t | Put (const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing. More...
size_t | PutWord16 (word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing. More...
size_t | PutWord32 (word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing. More...
size_t | PutWord64 (word64 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 64-bit word for processing. More...
virtual bool | CanModifyInput () const
| Determines whether input can be modified by the callee. More...
size_t | PutModifiable (byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee. More...
bool | MessageEnd (int propagation=-1, bool blocking=true)
| Signals the end of messages to the object. More...
size_t | PutMessageEnd (const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message. More...
unsigned int | GetMaxWaitObjectCount () const
| Retrieves the maximum number of waitable objects.
void | GetWaitObjects (WaitObjectContainer &container, CallStack const &callStack)
| Retrieves waitable objects. More...
virtual void | SetAutoSignalPropagation (int propagation)
| Set propagation of automatically generated and transferred signals. More...
virtual int | GetAutoSignalPropagation () const
| Retrieve automatic signal propagation value. More...
virtual lword | MaxRetrievable () const
| Provides the number of bytes ready for retrieval. More...
virtual bool | AnyRetrievable () const
| Determines whether bytes are ready for retrieval. More...
virtual size_t | Get (byte &outByte)
| Retrieve a 8-bit byte. More...
virtual size_t | Get (byte *outString, size_t getMax)
| Retrieve a block of bytes. More...
virtual size_t | Peek (byte &outByte) const
| Peek a 8-bit byte. More...
virtual size_t | Peek (byte *outString, size_t peekMax) const
| Peek a block of bytes. More...
size_t | GetWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 16-bit word. More...
size_t | GetWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 32-bit word. More...
size_t | GetWord64 (word64 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 64-bit word. More...
size_t | PeekWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 16-bit word. More...
size_t | PeekWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 32-bit word. More...
size_t | PeekWord64 (word64 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 64-bit word. More...
lword | TransferTo (BufferedTransformation &target, lword transferMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL)
| move transferMax bytes of the buffered output to target as input More...
virtual lword | Skip (lword skipMax=LWORD_MAX)
| Discard skipMax bytes from the output buffer. More...
lword | CopyTo (BufferedTransformation &target, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object to another BufferedTransformation. More...
lword | CopyRangeTo (BufferedTransformation &target, lword position, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object using an index to another BufferedTransformation. More...
virtual lword | TotalBytesRetrievable () const
| Provides the number of bytes ready for retrieval. More...
virtual unsigned int | NumberOfMessages () const
| Provides the number of meesages processed by this object. More...
virtual bool | AnyMessages () const
| Determines if any messages are available for retrieval. More...
virtual bool | GetNextMessage ()
| Start retrieving the next message. More...
virtual unsigned int | SkipMessages (unsigned int count=UINT_MAX)
| Skip a number of meessages. More...
unsigned int | TransferMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL)
| Transfer messages from this object to another BufferedTransformation. More...
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation. More...
virtual void | SkipAll ()
| Skip all messages in the series.
void | TransferAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL)
| Transfer all bytes from this object to another BufferedTransformation. More...
void | CopyAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation. More...
virtual bool | GetNextMessageSeries ()
| Retrieve the next message in a series. More...
virtual unsigned int | NumberOfMessagesInThisSeries () const
| Provides the number of messages in a series. More...
virtual unsigned int | NumberOfMessageSeries () const
| Provides the number of messages in a series. More...
size_t | TransferMessagesTo2 (BufferedTransformation &target, unsigned int &messageCount, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer messages from this object to another BufferedTransformation. More...
size_t | TransferAllTo2 (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer all bytes from this object to another BufferedTransformation. More...
size_t | ChannelPut (const std::string &channel, byte inByte, bool blocking=true)
| Input a byte for processing on a channel. More...
size_t | ChannelPut (const std::string &channel, const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing on a channel. More...
size_t | ChannelPutModifiable (const std::string &channel, byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee on a channel. More...
size_t | ChannelPutWord16 (const std::string &channel, word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing on a channel. More...
size_t | ChannelPutWord32 (const std::string &channel, word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing on a channel. More...
size_t | ChannelPutWord64 (const std::string &channel, word64 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 64-bit word for processing on a channel. More...
bool | ChannelMessageEnd (const std::string &channel, int propagation=-1, bool blocking=true)
| Signal the end of a message. More...
size_t | ChannelPutMessageEnd (const std::string &channel, const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message. More...
virtual byte * | ChannelCreatePutSpace (const std::string &channel, size_t &size)
| Request space which can be written into by the caller. More...
virtual size_t | ChannelPut2 (const std::string &channel, const byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes for processing on a channel. More...
virtual size_t | ChannelPutModifiable2 (const std::string &channel, byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee on a channel. More...
virtual bool | ChannelFlush (const std::string &channel, bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output on a channel. More...
virtual bool | ChannelMessageSeriesEnd (const std::string &channel, int propagation=-1, bool blocking=true)
| Marks the end of a series of messages on a channel. More...
virtual void | SetRetrievalChannel (const std::string &channel)
| Sets the default retrieval channel. More...
virtual void | Attach (BufferedTransformation *newAttachment)
| Add newAttachment to the end of attachment chain. More...
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms. More...
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm. More...
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm. More...
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object. More...
Public Member Functions inherited from Waitable
bool | Wait (unsigned long milliseconds, CallStack const &callStack)
| Wait on this object. More...

## Detailed Description

Measure how many bytes and messages pass through the filter.

measure how many bytes and messages pass through the filter. The filter also serves as valve by maintaining a list of ranges to skip during processing.

Definition at line 232 of file filters.h.

## Constructor & Destructor Documentation

## ◆ MeterFilter()

MeterFilter::MeterFilter | ( | BufferedTransformation * | attachment = `NULL`,
|  | bool | transparent = `true`
| ) |  |
| inline

Construct a MeterFilter.

Parameters

  attachment | an optional attached transformation
  transparent | flag indicating if the filter should function transparently

attachment can be NULL. The filter is transparent by default. If the filter is transparent, then PutMaybeModifiable() does not process a request and always returns 0.

Definition at line 242 of file filters.h.

## Member Function Documentation

## ◆ SetTransparent()

void MeterFilter::SetTransparent | ( | bool | transparent | ) |
| inline

Set or change the transparent mode of this object.

Parameters

  transparent | the new transparent mode

Definition at line 249 of file filters.h.

## ◆ AddRangeToSkip()

void MeterFilter::AddRangeToSkip | ( | unsigned int | message,
|  | lword | position,
|  | lword | size,
|  | bool | sortNow = `true`
| ) |  |

Adds a range to skip during processing.

Parameters

  message | the message to apply the range
  position | the 0-based index in the current stream
  size | the length of the range
  sortNow | flag indicating whether the range should be sorted

Internally, MeterFilter maitains a deque of ranges to skip. As messages are processed, ranges of bytes are skipped according to the list of ranges.

Definition at line 166 of file filters.cpp.

## ◆ ResetMeter()

void MeterFilter::ResetMeter | ( |  | ) |

Resets the meter.

ResetMeter() reinitializes the meter by setting counters to 0 and removing previous skip ranges.

Definition at line 160 of file filters.cpp.

## ◆ IsolatedInitialize()

void MeterFilter::IsolatedInitialize | ( | const NameValuePairs & | parameters | ) |
| inline virtual

Initialize or reinitialize this object, without signal propagation.

Parameters

  parameters | a set of NameValuePairs to initialize this object

Exceptions

  NotImplemented |

IsolatedInitialize() is used to initialize or reinitialize an object using a variable number of arbitrarily typed arguments. The function avoids the need for multiple constructors providing all possible combintations of configurable parameters.

IsolatedInitialize() does not call Initialize() on attached transformations. If initialization should be propagated, then use the Initialize() function.

If a derived class does not override IsolatedInitialize(), then the base class throws NotImplemented.

Reimplemented from BufferedTransformation.

Definition at line 266 of file filters.h.

## ◆ GetCurrentMessageBytes()

lword MeterFilter::GetCurrentMessageBytes | ( |  | ) | const
| inline

Number of bytes in the current message.

Returns
  GetCurrentMessageBytes() returns the number of bytes in the current message

Definition at line 271 of file filters.h.

## ◆ GetTotalBytes()

lword MeterFilter::GetTotalBytes | ( |  | ) | const
| inline

Number of bytes processed by the filter.

Returns
  GetTotalBytes() returns the number of bytes processed by the filter

Definition at line 275 of file filters.h.

## ◆ GetCurrentSeriesMessages()

unsigned int MeterFilter::GetCurrentSeriesMessages | ( |  | ) | const
| inline

Message number in the series.

Returns
  GetCurrentSeriesMessages() returns the message number in the series

Definition at line 279 of file filters.h.

## ◆ GetTotalMessages()

unsigned int MeterFilter::GetTotalMessages | ( |  | ) | const
| inline

Number of messages in the message series.

Returns
  GetTotalMessages() returns the number of messages in the message series

Definition at line 283 of file filters.h.

## ◆ GetTotalMessageSeries()

unsigned int MeterFilter::GetTotalMessageSeries | ( |  | ) | const
| inline

Number of messages processed by the filter.

Returns
  GetTotalMessageSeries() returns the number of messages processed by the filter

Definition at line 287 of file filters.h.

## ◆ CreatePutSpace()

byte* MeterFilter::CreatePutSpace | ( | size_t & | size | ) |
| inline virtual

Request space which can be written into by the caller.

Parameters

  size | the requested size of the buffer

Returns
  byte pointer to the space to input data

The purpose of this method is to help avoid extra memory allocations.

size is an IN and OUT parameter and used as a hint. When the call is made, size is the requested size of the buffer. When the call returns, size is the size of the array returned to the caller.

The base class implementation sets size to 0 and returns NULL.

Note
  Some objects, like ArraySink, cannot create a space because its fixed. In the case of an ArraySink, the pointer to the array is returned and the size is remaining size.

Reimplemented from BufferedTransformation.

Definition at line 290 of file filters.h.

## ◆ Put2()

size_t MeterFilter::Put2 | ( | const byte * | inString,
|  | size_t | length,
|  | int | messageEnd,
|  | bool | blocking
| ) |  |
| virtual

Input multiple bytes for processing.

Parameters

  inString | the byte buffer to process
  length | the size of the string, in bytes
  messageEnd | means how many filters to signal MessageEnd() to, including this one
  blocking | specifies whether the object should block when processing input

Returns
  the number of bytes that remain to be processed (i.e., bytes not processed). 0 indicates all bytes were processed.

Derived classes must implement Put2().

Implements BufferedTransformation.

Definition at line 232 of file filters.cpp.

## ◆ PutModifiable2()

size_t MeterFilter::PutModifiable2 | ( | byte * | inString,
|  | size_t | length,
|  | int | messageEnd,
|  | bool | blocking
| ) |  |
| virtual

Input multiple bytes that may be modified by callee.

Parameters

  inString | the byte buffer to process.
  length | the size of the string, in bytes.
  messageEnd | means how many filters to signal MessageEnd() to, including this one.
  blocking | specifies whether the object should block when processing input.

Returns
  the number of bytes that remain to be processed (i.e., bytes not processed). 0 indicates all bytes were processed.

Internally, PutModifiable2() calls Put2().

Reimplemented from BufferedTransformation.

Definition at line 237 of file filters.cpp.

## ◆ IsolatedMessageSeriesEnd()

bool MeterFilter::IsolatedMessageSeriesEnd | ( | bool | blocking | ) |
| virtual

Marks the end of a series of messages, without signal propagation.

Parameters

  blocking | specifies whether the object should block when completing the processing on the current series of messages

Returns
  true if the message was successful, false otherwise

Reimplemented from BufferedTransformation.

Definition at line 242 of file filters.cpp.

The documentation for this class was generated from the following files:

- filters.h
- filters.cpp